<template>
  <div class="box p-3 md:p-10">
    <div class="md:flex justify-between">
      <div class="text-xl italic text-gray-500 font-bold">
        {{ filledForm.raised_form.name }}
      </div>
      <div class="text-gray-500">
        <Icon icon="fa-solid fa-clock" class="mr-2"></Icon>Submitted on {{ new
          Date(filledForm.raised_form.updated_at).toLocaleString() }}
      </div>
    </div>

    <div v-if="type !== 'approvingForm'" class="space-y-4 mt-5 bg-white p-6 rounded-lg ">
  <div v-if="approvals.length" class="mb-4">
    <label class="text-lg font-semibold text-gray-700">Approval Status:</label>
    <Status :status="filledForm.approval_status"></Status>
  </div>

  <div v-for="approval in approvals" class="mb-4 p-4 border rounded-lg bg-gray-50">
    <div class="flex items-center space-x-2 mb-2">
      <span class="text-sm font-medium text-gray-600">Stage {{ approval.stage }}:</span>
      <Icon icon="fa-solid fa-user" class="text-gray-500"></Icon>
      <span class="text-sm text-gray-600" v-if="approval.user">{{ approval.user.name }} ({{ approval.user.role.name }})</span>
      <span class="text-sm text-gray-600" v-else>(User not found!)</span>
    </div>
    <Status :status="approval.status"></Status>
  </div>

  <div>
    <label class="block text-lg font-semibold text-gray-700 mb-2">Approval Remarks</label>

    <div v-for="approval in approvalWRemarks" class="mb-6">
      <textarea class="textarea-disabled w-full bg-gray-100 border rounded-lg p-2 text-sm text-gray-600" disabled :value="approval.remarks"></textarea>
      <div class="mt-2 flex justify-end items-center space-x-2">
        <Status :status="approval.status"></Status>
        <div class="text-sm text-gray-600">
          <span v-if="approval.user">by {{ approval.user.name }} ({{ approval.user.role.name }})</span>
          <span v-else>by (User not found!)</span>
          <span class="mr-2"> on Stage {{ approval.stage }}</span>
        </div>
      </div>
    </div>
  </div>
</div>


    <div class="mt-10 text-lg space-y-5">
      <div v-for="fff in fffs">
        <div>
          <label v-if="fff.form_field.field.type === 'Title'" class="text-gray-600 text-base font-bold italic">
            {{ fff.form_field.field.name }}
          </label>
          <label v-else-if="fff.form_field.field.type === 'Description'" class="text-gray-500 text-base">
            {{ fff.form_field.field.name }}
          </label>
          <div v-else>
            {{ fff.form_field.field.index + 1 - fffs.slice(0, fff.form_field.field.index).filter((fff) => fff.form_field.field.type === 'Title' ||
              fff.form_field.field.type === 'Description').length }}. {{ fff.form_field.field.name }}
            <span v-if="fff.form_field.field.required" class="text-lg text-orange-500">*</span>
          </div>
        </div>
        <fieldset class="mb-1" disabled>
          <input :value="fff.value" class="w-full input-disabled" type="text"
            v-if="fff.form_field.field.type === 'Text'" />
          <input :value="fff.value" class="w-full input-disabled" type="number"
            v-else-if="fff.form_field.field.type === 'Number'" />
          <input :value="fff.date_value" class="w-full input-disabled" type="date"
            v-else-if="fff.form_field.field.type === 'Date'" />
          <div v-else-if="fff.form_field.field.type === 'File'">
            <span v-if="!fff.file" class="italic">Empty</span>
            <a v-else :href="fff.file?.src" class="block italic text-sm text-gray-500">
              <Icon icon="fa-solid fa-download"></Icon> Download
            </a>
          </div>
          <textarea :value="fff.value" class="w-full textarea-disabled"
            v-else-if="fff.form_field.field.type === 'Text Area'" />
          <div v-else-if="fff.form_field.field.type === 'Checkbox'">
            <fieldset v-for="option in fff.form_field.field.options">
              <input :value="fff.value" :checked="fff.selected_options.map((so) => so.value).includes(option.value)"
                type="checkbox" class="checkbox-disabled">
              <label class="text-sm ms-2">{{ option.value }}</label>
            </fieldset>
          </div>
          <div v-else-if="fff.form_field.field.type === 'Radio Button'">
            <fieldset v-for="option in fff.form_field.field.options">
              <input :value="fff.value" type="radio" class="radio-disabled">
              <label class="text-sm ms-2">{{ option.value }}</label>
            </fieldset>
          </div>
          <select :value="fff.value" class="w-full input-disabled" v-else-if="fff.form_field.field.type === 'Dropdown'">
            <option v-for="option in fff.form_field.field.options">
              {{ option.value }}
            </option>
          </select>
        </fieldset>
      </div>
    </div>

    <div v-if="type === 'approvingForm'" class="mt-5 space-y-5">
      <div>
        <label class="block text-base font-semibold">Form Approvals</label>

        <div v-for="approval in approvals">
          <span class="text-sm mr-2">Stage {{ approval.stage }}:</span>
          <Icon icon="fa-solid fa-user" class="text-sm text-gray-500"></Icon>
          <span class="text-sm" v-if="approval.user">{{ approval.user.name }} ({{ approval.user.role.name
            }})</span>
          <span class="text-sm" v-else>(User not found!)</span>
          <Status :status="approval.status"></Status>
        </div>
        <div class="text-sm" v-if="approvals.length === 0">
          No Approvers found!
        </div>
      </div>

      <div>
        <label class="block text-base font-semibold">Approval Remarks</label>

        <div v-for="approval in approvalWRemarks">
          <textarea class="textarea-disabled w-full" disabled :value="approval.remarks"></textarea>
          <div class="-mt-2 mb-6 flex justify-end">
            <div>
              <Status :status="approval.status"></Status>
              <span class="text-sm" v-if="approval.user"> by {{ approval.user.name }} ({{
                approval.user.role.name
              }})</span>
              <span class="text-sm" v-else>by (User not found!)</span>
              <span class="text-sm mr-2"> on Stage {{ approval.stage }}</span>
            </div>
          </div>
        </div>
      </div>

      <div>
        <label class="block text-base font-semibold">Do you want to approve or reject this Form?</label>
 
        <fieldset class="flex text-sm gap-x-10 mt-2">
          <div class="flex items-center gap-x-2">
            <input class="radio" type="radio" value="Approved" v-model="form.status">
            Approve
          </div>

          <div class="flex items-center gap-x-2">
            <input class="radio" type="radio" value="Rejected" v-model="form.status">
            Reject
          </div>
        </fieldset>

        <div v-if="form.errors.status" class="text-error">
          {{ form.errors.status }}
        </div>
      </div>

      <div>
        <label class="block text-base font-semibold">Write your approval remarks</label>

        <textarea class="textarea mt-2 w-full" placeholder="Leave a remark here" v-model="form.remarks">
      </textarea>
      </div>

      <div class="flex justify-end gap-x-3">
        <button type="submit" class="btn bg-green-500 text-white px-4 py-2 rounded-md hover:bg-green-600 focus:outline-none focus:ring-2 focus:ring-green-500 focus:ring-offset-2" @click="form.put(`/form/formRequest/${filledForm.id}`, { preserveScroll: true })">Save</button>
    <Link href="/alert" class="btn bg-gray-200 text-gray-700 px-4 py-2 ml-3 rounded-md hover:bg-gray-300 focus:outline-none focus:ring-2 focus:ring-gray-500 focus:ring-offset-2">Cancel</Link>
      
       
      </div>
    </div>

  </div>
</template>

<script setup>
import Status from '@/Components/Status.vue';
import { Link, useForm } from '@inertiajs/vue3';
import { computed } from 'vue';

const props = defineProps({
  filledForm: Object,
  type: String
})

const fffs = computed(() => props.filledForm.filled_form_fields.sort((fffA, fffB) => fffA.form_field.field.index - fffB.form_field.field.index))
const approvals = computed(() => props.filledForm.approvals?.sort((approvalA, approvalB) => approvalA.stage - approvalB.stage) ?? [])
const approvalWRemarks = computed(() => props.filledForm.approvals?.sort((approvalA, approvalB) => approvalA.stage - approvalB.stage).filter(approval => approval.status !== 'Pending' && approval.remarks) ?? [])

const form = useForm({
  status: null,
  remarks: ''
})
</script>